unit EnumServer;
interface

uses
	Windows, Messages, SysUtils,Classes, Graphics, Controls, Forms,
	Dialogs, StdCtrls;
Const
	MAX_NO_SERVER  = 10;

type
TEnumServerForm = class(TForm)
   L_iEnumFlag: TLabel;
   C_iEnumFlag: TComboBox;
   L_iDevID: TLabel;
   E_iDevID: TEdit;
   L_iNumServers: TLabel;
   E_i_NumServers: TEdit;
   L_oServerInfo: TLabel;
   Execute_Enum: TButton;
   Cancle_Enum: TButton;
   C_oServers: TComboBox;
   procedure Execute_EnumClick(Sender: TObject);
   procedure Cancle_EnumClick(Sender: TObject);
private
{ Private declarations }
public
{ Public declarations }
end;

var
   EnumServerForm: TEnumServerForm;

implementation

uses
   Spromeps, Eval;

{$R *.dfm}

{******************************************************************************
Function        : Execute_EnumClick
******************************************************************************}

procedure TEnumServerForm.Execute_EnumClick(Sender: TObject);
   var
      DevID : WORD;
      numServer : WORD;
      EnumFlag :Integer;
      i :Integer;
      status:WORD ;
      temp :String;
      serverInfo: ARRAY [1..MAX_NO_SERVER ]OF NSPRO_SERVER_INFO;
      index : WORD;
   begin

      index := C_iEnumFlag.ItemIndex ;
      if ((index <> 0 )and (index <> 1)and (index <> 2)) then
         MessageDlg('Select one of the EnumFlag.',
                           mtError, [mbOK], 0)
      else
      begin
         C_oServers.Items.Clear;
         if index = 0  then
            EnumFlag := NSPRO_RET_ON_FIRST
         else if index = 1  then
            EnumFlag := NSPRO_GET_ALL_SERVERS
         else if index = 2  then
            EnumFlag := NSPRO_RET_ON_FIRST_AVAILABLE  
         else
          EnumFlag := NSPRO_RET_ON_FIRST ;
         if E_iDevID.Text <> '' then
         begin
            if (length(E_iDevID.Text) <= MAX_DEVID_LENGTH)  then
            begin
               try
                  DevID := StrToInt('$' + E_iDevID.Text);
                  if E_i_NumServers.Text <> '' then
                  begin
                     try
                        numServer := StrToInt(E_i_NumServers.Text);
                        if (not((numServer > MAX_NUM_SERVER ) or (numServer < MIN_NUM_SERVER))) then
                        begin
                           status := SproEnumServer(EnumFlag,DevID ,@serverInfo,@numServer);
                           if status <> 0 then
                              MessageDlg('EnumServer failed! Return code is '+ IntToStr(status)+ '.',
                                                mtError, [mbOK], 0)
                           else
                           begin
                              MessageDlg('EnumServer successful! Click Server Info box to see details.' ,
                              mtInformation, [mbOK], 0)   ;
                              E_i_NumServers.Text:= IntToStr(numServer);
                              for i:=1 to numServer do 
                              begin
                                 temp:='';
                                 temp:= IntToStr(serverInfo[i].numLicAvail)+' , '+ serverInfo[i].serverAddress ;
                                 C_oServers.Items.Add(temp);
                              end;
                           end;
                        end
                        else
                           MessageDlg('Number of server must be between 1 to 10.',
                                             mtError, [mbOK], 0);
                     except
                        on EConvertError do
                           MessageDlg('Number of server must be between 1 to 10.',
                                             mtError, [mbOK], 0);
                     end;
                  end
                  else
                     MessageDlg('Specify number of server to proceed.',
                                       mtError, [mbOK], 0);
               except
                  on EConvertError do
                     MessageDlg('DevID must be in hex with length not exceeding 4 digit.',
                                       mtError, [mbOK], 0);
               end;
            end
            else
               MessageDlg('DevID must be in hex with length not exceeding 4 digit.',
                                 mtError, [mbOK], 0);
         end
         else
            MessageDlg('Specify DeveloperID to proceed.',
                              mtError, [mbOK], 0);
      end;
   end;


{******************************************************************************
Function        : Cancle_EnumClick
******************************************************************************}

procedure TEnumServerForm.Cancle_EnumClick(Sender: TObject);
   begin
      E_iDevID.Text:='';
      E_i_NumServers.Text:='' ;
      C_oServers.Items.Clear;
      close;
   end;

end.




