unit Eval;

	{ WARNING!!! These compiler directives MUST be defined for the SuperPro }
	{ driver to operate correctly!                                          }

	{$F+} { Force FAR calls }
	{$P-} { Turn open parameters OFF }
	{$V-} { Turn OFF strict string parameter checking }
	{$H-}

interface

	uses
	SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
	Forms, Dialogs, Grids, StdCtrls, ExtCtrls, Buttons;

type
   TMainForm = class(TForm)
   KeyGrid: TStringGrid;
   GroupBox1: TGroupBox;
   ViewBtn: TButton;
   PasswordBtn: TButton;
   GroupBox2: TGroupBox;
   ExitBtn: TButton;
   Image1: TImage;
   Label1: TLabel;
   Label2: TLabel;
   GroupBox3: TGroupBox;
   LabelCellNo: TLabel;
   CellNumber: TEdit;
   LabelAccCode: TLabel;
   AccessCode: TEdit;
   LabelInput: TLabel;
   Input: TEdit;
   LabelOutput: TLabel;
   Output: TEdit;
   LabelStatus: TLabel;
   LabelProtocol: TLabel;
   ComboBoxProtocolFlag: TComboBox;
   LabelServerName: TLabel;
    ServerName: TComboBox;
   GroupBox4: TGroupBox;
   FormatPkt: TButton;
   InitializeBtn: TButton;
   SetProtocol: TButton;
   SetContactSrvBtn: TButton;
   FindFirstBtn: TButton;
   FindNextBtn: TButton;
   GetContactSrv: TButton;
   HeartBeat: TButton;
   ReadBtn: TButton;
   WriteBtn: TButton;
   QueryBtn: TButton;
   XReadBtn: TButton;
   OverwriteBtn: TButton;
   ActivateBtn: TButton;
   DecrementBtn: TButton;
   VersionBtn: TButton;
   GetHardLmt: TButton;
   GetSubLicBtn: TButton;
   StatusBtn: TButton;
   KeyInfo: TButton;
   ReleaseLicBtn: TButton;
   EnumServer: TButton;
   StatusLine: TMemo;
   procedure ExitBtnClick(Sender: TObject);
   procedure PasswordBtnClick(Sender: TObject);
   procedure FormCreate(Sender: TObject);
   procedure FormActivate(Sender: TObject);
   procedure FindFirstBtnClick(Sender: TObject);
   procedure ViewBtnClick(Sender: TObject);
   procedure FindNextBtnClick(Sender: TObject);
   procedure ReadBtnClick(Sender: TObject);
   procedure XReadBtnClick(Sender: TObject);
   procedure OverwriteBtnClick(Sender: TObject);
   procedure WriteBtnClick(Sender: TObject);
   procedure QueryBtnClick(Sender: TObject);
   procedure DecrementBtnClick(Sender: TObject);
   procedure ActivateBtnClick(Sender: TObject);
   procedure StatusBtnClick(Sender: TObject);
   procedure VersionBtnClick(Sender: TObject);
   procedure KeyGridSelectCell(Sender: TObject; Col, Row: Longint;var CanSelect: Boolean);
   procedure SetContactSrvBtnClick(Sender: TObject);
   procedure GetContactSrvClick(Sender: TObject);
   procedure GetSubLicBtnClick(Sender: TObject);
   procedure ReleaseLicBtnClick(Sender: TObject);
   procedure InitializeBtnClick(Sender: TObject);
   procedure GetHardLmtClick(Sender: TObject);
   procedure HeartBeatClick(Sender: TObject);
   procedure SetProtocolClick(Sender: TObject);
   procedure FormatPktClick(Sender: TObject);
   procedure KeyInfoClick(Sender: TObject);
   procedure EnumServerClick(Sender: TObject);

private
public
{ Public declarations }
end;

{ prototypes }

{ query string conversion routines }
   FUNCTION HexCharToDigit (hexChar : CHAR) : BYTE;
   FUNCTION MakeHexChar (num : BYTE) : CHAR;
   PROCEDURE ConvertQueryStr (queryStr : STRING; VAR realQueryStr : STRING);
   PROCEDURE ConvertResponseStr (responseStr : STRING; VAR disResponseStr : STRING);
{ sproeval general routines }
   //function StatusDesc(status: WORD): string;
   procedure ViewKey;
  Const
   // SOME CONSTANT FOR INPUTS VALIDATION

 MAX_DEVID_LENGTH                   = 4;
 MAX_ADDRESS_LENGTH               = 2;
 MAX_ACCESS_CODE            = 3;
 MIN_ACCESS_CODE             = 0;
 MAX_DATA_LENGTH                  = 4;
 MAX_NUM_SERVER                 = 10;
 MIN_NUM_SERVER                = 1;
 MIN_NUM_LICENESE            = 0;
 MAX_NUM_LICENESE            =65535 ;
 MAX_PASSWORDS_LENGTH             = 4;
 MIN_QUERY_LENGTH                   = 8;
  MAX_SERVER_LENGTH                = 64;

   var
      MainForm: TMainForm;
      DevID,
      WritePW ,
      OverWritePW1,
      OverWritePW2 : WORD;
      NextKey :WORD;
      Valid_OWritePW,
      Valid_WritePW :boolean;
      pwWord1, pwWord2 : WORD;

implementation
{$R *.DFM}

uses
	Windows,SproMeps, Password, Activate,EnumServer,Key_Info;


{*=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-*}
{*      Start of query string conversion routines                           *}

{******************************************************************************
Procedure       : HexCharToDigit
Purpose         : To convert a hex character to a digit
Inputs          : Hex character

Outputs         : digit between 0 and 15

Description     : Convert the character to it's numeric equivalent

Note: There is no check on the specified character.  Any
invalid hex character will return a value of 0.

******************************************************************************}
FUNCTION HexCharToDigit (hexChar : CHAR) : BYTE;

   VAR
      digit : BYTE;

   BEGIN

      CASE UpCase (hexChar) OF
         '0'..'9' : digit := ORD (hexChar) - ORD ('0');
         'A'..'F' : digit := ( ORD (hexChar) - ORD ('A') ) + 10;
      ELSE
         digit := 0;
      END; { CASE }

      HexCharToDigit := digit;
   END; { HexCharToDigit }

{******************************************************************************
Procedure       : MakeHexChar

Purpose         : To make a hex character from an integer

Inputs          : BYTE 0 - 15

Outputs         : hex character

Description     : Hex characters can be 0 - 9, A - F.
Any number over 15 will become F.
******************************************************************************}
FUNCTION   MakeHexChar (num : BYTE) : CHAR;

   VAR
      offset : WORD;
   BEGIN
      IF num < 10 THEN
         offset := ORD ('0') + num
      ELSE
      IF num <= 15 THEN
         offset := ORD ('A') + num - 10
      ELSE
         offset := ORD ('F');
      MakeHexChar := CHR (offset);
   END; { MakeHexChar }



FUNCTION IsHex(hexChar : CHAR) : CHAR;

   VAR
      digit : CHAR;

   BEGIN

      CASE UpCase (hexChar) OF
         '0'..'9' : digit := 'y';
         'A'..'F' : digit := 'y'
      ELSE
         digit := 'n';
      END; { CASE }
   IsHex:= digit;
   END; { HexCharToDigit }

 FUNCTION IsHexChar (queryStr : STRING) :WORD;

   VAR
    querylength,index: WORD;
    retval:CHAR;

   BEGIN
    Result:=0; // avoids compiler warning
    querylength := length(queryStr);
    for index:= 1 To querylength  do
    begin
        retval:= IsHex(queryStr[index]);

        if (retval='n') then
          begin
            Result:=1;
            break;
          end
        else
           Result:=0;
    end;

   END; { MakeHexChar }


  {inputStrLen = strlen(dataString);
   for(index= 0; index<inputStrLen; index++)
   {
      memset(szTempInputStr,0,sizeof(szTempInputStr));
      sprintf(szTempInputStr, "%c",dataString[index]);
      retVal = sscanf(szTempInputStr,"%x",&tempOutput);
      if(retVal <= 0)
        return 2;
   }


  {******************************************************************************
Procedure       : ConvertQueryStr

Purpose         : To convert the query string to a real query string

Inputs          : Query string

Outputs         : Real query string

Description     : The query string is entered as hex characters.
The real query string combines each 2 hex characters into one
byte.

Note: The query string must be an even number of bytes.
******************************************************************************}
PROCEDURE ConvertQueryStr (queryStr : STRING; VAR realQueryStr : STRING);

   VAR
      i, stop, num : WORD;
      digit : BYTE;

   BEGIN
      i := 1;
      realQueryStr := '';
      stop := Length (queryStr);
      WHILE i < stop DO
      BEGIN
         digit := HexCharToDigit (queryStr [i]);
         num := digit;
         { the first char is the high order hex byte }
         num := num shl 4;
         Inc (i);
         digit := HexCharToDigit (queryStr [i]);
         { add the low order byte }
         num := num + digit;
         Inc (i);
         realQueryStr := realQueryStr + CHR (num);
      END; { WHILE }

   END; { ConvertQueryStr }

{******************************************************************************
Procedure       : ConvertResponseStr

Purpose         : To query an algorithm word

Inputs          : Response string

Outputs         : Display response string

Description     : Each character in the response string will be converted to
2 hex characters for display

Note: The display response string should be twice as large as
the length of the response string.
******************************************************************************}
PROCEDURE ConvertResponseStr (responseStr : STRING; VAR disResponseStr : STRING);

   VAR
      i, stop : WORD;
      digit : BYTE;

   BEGIN

      i := 1;
      disResponseStr := '';
      stop := Length (responseStr);

      WHILE i <= stop DO BEGIN
         { get the hi order hex digit }
         digit := ORD (responseStr [i]);
         digit := digit shr 4;
         disResponseStr := disResponseStr + MakeHexChar (digit);
         { get the lo order hex digit }
         digit := ORD (responseStr [i]);
         digit := digit AND $0F;
         disResponseStr := disResponseStr + MakeHexChar (digit);
         Inc (i);
      END; { WHILE }

   END; { ConvertResponseStr }

{*       End of query string conversion routines                            *}
{*=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-*}


{******************************************************************************
Procedure       : DriverType

Purpose         : To DISPLAY driver type string

Inputs          : driver type value

Outputs         : Display  driver type string

******************************************************************************}

function DriverType(status: WORD): string;
   begin
      case (status and $FF) of
         RB_WINNT_SYS_DRVR                 : result := '5(Windows NT System Driver)';
         RB_WIN95_SYS_DRVR                 : result := '7(Windows 95 System Driver)';
         RB_NW_LOCAL_DRVR                  : result := '8(Novell System Driver)';
         10                                : result := '10(Unknown System Driver)';
      end;
   end;

{******************************************************************************
Function        : ViewKey

Purpose         : Reads key contents into key table.

Inputs          : None.

Outputs         : None.

Description     : Builds key table based upon the contents of the currently
active SuperPro.  Cells with restricted access (code 3) are
assigned '????'.
******************************************************************************}
procedure ViewKey;
   var
      i, status, dataAccessCode : WORD;
      data : WORD;
   begin
      for i := 0 to $3F do
      begin
         status := SproExtendedRead(@thePacket, i, @data, @dataAccessCode);
         if status = 0 then
            if (dataAccessCode and $03) = 3 then
               MainForm.KeyGrid.Cells[i mod 16 + 1, i div 16 + 1] := '????'
            else
               MainForm.KeyGrid.Cells[i mod 16 + 1, i div 16 + 1] := IntToHex(data, 4)
         else { assume cell is algo/password }
            MainForm.KeyGrid.Cells[i mod 16 + 1, i div 16 + 1] := '????';
      end;
   end;

{ event handlers }


{******************************************************************************
Function        : ExitBtnClick
******************************************************************************}

procedure TMainForm.ExitBtnClick(Sender: TObject);
   Var
      x: Integer;
   begin
      x := 0;
      SproReleaseLicense(@thePacket,0,@x);
      close;
      end;

      procedure TMainForm.PasswordBtnClick(Sender: TObject);
      begin

      PWForm.WPW.Text := IntToHex(WritePW,4);
      PWForm.OPW1.Text :=IntToHex(OverWritePW1,4);
      PWForm.OPW2.Text := IntToHex(OverWritePW2,4);
      PWForm.ShowModal;


end;



{******************************************************************************
Function        : FormCreate
{******************************************************************************}

procedure TMainForm.FormCreate(Sender: TObject);
   var
      i, error : WORD;
   begin
      for i := 1 to KeyGrid.ColCount - 1 do
      begin
         KeyGrid.Cells[i, 0] := IntToHex(i - 1, 4);
         KeyGrid.Cells[0, i] := IntToHex(i - 1, 4);
      end;

   { Initialize the driver }

      error := SproFormatPacket(@thePacket,RB_SPRO_APIPACKET_SIZE);
      if error <> 0 then
      begin
         MessageDlg('Error '+ IntToStr(error) + ' calling SproFormatPacket.',
                           mtError, [mbOK], 0);
         close;
      end;
      {error := SproSetContactServer(@thePacket,'no-net');
      if error <> 0 then
      begin
         MessageDlg('Error '+ IntToStr(error) + ' calling SproSetContactServer to no-net.',
                           mtError, [mbOK], 0);
         close;
      end; }
   end;

{******************************************************************************
Function        : FormActivate
{******************************************************************************}

procedure TMainForm.FormActivate(Sender: TObject);
   begin
      WritePW :=0;
      OverWritePW1:=0;
      OverWritePW2:=0;
      Valid_OWritePW:=false;
      Valid_WritePW:=false;
      ComboBoxProtocolFlaG.ItemIndex:=0;
      //CellNumber.Text := IntToHex((KeyGrid.Row - 1) * 16 + (KeyGrid.Col - 1), 2);
   end;


{******************************************************************************
Function        : FindFirstBtnClick
{******************************************************************************}

procedure TMainForm.FindFirstBtnClick(Sender: TObject);
   var
      status : WORD;
   begin
      if Input.Text <> '' then
      begin
         if (length(Input.Text) <= MAX_DEVID_LENGTH)  then
         begin
            try
               DevID := StrToInt('$' + Input.Text);
               status := SproFindFirstUnit(@thePacket, DevID);

               if status=0 then
               BEGIN
           CellNumber.Text := '';
               AccessCode.Text := '';
               Input.Text := '';
               Output.Text := '';
                  StatusLine.Text:='';
                  StatusLine.Text := 'FindFirstUnit successful! ';
               END
               else
               begin
                  StatusLine.Text:='';
                  StatusLine.Text := 'FindFirstUnit failed!'+#13 +#10;
                  StatusLine.Text := StatusLine.Text + 'Return code is '+ IntToStr(status)+ '.';
               end;
            except
               on EConvertError do
                  MessageDlg('DeveloperID must be a hex with length not exceeding 4 digit.',
                                    mtError, [mbOK], 0);
            end;
         end
         else
            MessageDlg('DeveloperID must be a hex with length not exceeding 4 digit.' ,
                              mtError, [mbOK], 0);
      end
      else
         MessageDlg('Specify DeveloperID in input box to proceed.' ,
                           mtError, [mbOK], 0);
   end;



{******************************************************************************
Function        : ViewBtnClick
{******************************************************************************}

procedure TMainForm.ViewBtnClick(Sender: TObject);
   begin
      ViewKey;
      KeyGrid.Update;
      CellNumber.Text := '';
      AccessCode.Text := '';
      Input.Text := '';
      Output.Text := '';
      StatusLine.Text := '';

   end;


{******************************************************************************
Function        : FindNextBtnClick
{******************************************************************************}

procedure TMainForm.FindNextBtnClick(Sender: TObject);
   var
      status : WORD;
   begin
      status := SproFindNextUnit(@thePacket);
      if status=0 then
    begin
    CellNumber.Text := '';
      AccessCode.Text := '';
      Input.Text := '';
      Output.Text := '';
       StatusLine.Text:='';
         StatusLine.Text := 'FindNextUnit successful! '
    end
      else
      begin
      StatusLine.Text:='';
         StatusLine.Text := 'FindNextUnit failed!'+#13 +#10;
         StatusLine.Text := StatusLine.Text + 'Return code is '+ IntToStr(status)+ '.';
      end;
   end;


{******************************************************************************
Function        : ReadBtnClick
{******************************************************************************}

procedure TMainForm.ReadBtnClick(Sender: TObject);
   var
      status, address : WORD;
      data : WORD;
   begin
      if (CellNumber.Text <> '') then
      begin
         if (length(CellNumber.Text )<= MAX_ADDRESS_LENGTH ) then
         begin
            try
               address := StrToInt('$' + CellNumber.Text);
               status := SproRead(@thePacket, address, @data);

               if status <> 0 then
               begin
                  Output.Text :='';
                  StatusLine.Text:='';
                  StatusLine.Text := 'Read failed!'+#13 +#10;
                  StatusLine.Text := StatusLine.Text + 'Return code is '+ IntToStr(status)+ '.';
               end
               else
               begin
            AccessCode.Text := '';
               Input.Text := '';
               CellNumber.Text:= '' ;
                  Output.Text := IntToHex(data, 4);
                  StatusLine.Text:='';
                  StatusLine.Text := 'Read successful!';
               end;
            except
               on EConvertError do
                  MessageDlg('Cell No. must be a hex with length not exceeding 2 digit.',
                                    mtError, [mbOK], 0);
            end;
         end
         else
         MessageDlg('Cell No. must be a hex with length not exceeding 2 digit.' ,
                           mtError, [mbOK], 0);
      end
      else
         MessageDlg('Specify Cell No. to proceed.',
                           mtError, [mbOK], 0);
   end;


{******************************************************************************
Function        : XReadBtnClick
{******************************************************************************}

procedure TMainForm.XReadBtnClick(Sender: TObject);
   var
      status, address, dataAccessCode : WORD;
      data : WORD;
   begin
      if (CellNumber.Text <> '') then
      begin
         if (length(CellNumber.Text )<= MAX_ADDRESS_LENGTH ) then
         begin
            try
               address := StrToInt('$' + CellNumber.Text);
               status := SproExtendedRead(@thePacket, address, @data, @dataAccessCode);

               if status <> 0 then
               begin
            AccessCode.Text :='';
                  Output.Text :='';
                  StatusLine.Text:='';
                  StatusLine.Text := 'ExtendedRead failed!'+#13 +#10;
                  StatusLine.Text := StatusLine.Text + 'Return code is '+ IntToStr(status)+ '.';
               end
               else
               begin

            Input.Text := '';
               CellNumber.Text := '' ;
                  AccessCode.Text := IntToStr(dataAccessCode and $03);
                  Output.Text := IntToHex(data, 4);
                  StatusLine.Text:='';
                  StatusLine.Text := 'ExtendedRead successful!';
               end;
            except
               on EConvertError do
                  MessageDlg('Cell No. must be a hex with length not exceeding 2 digit.',
                                    mtError, [mbOK], 0);
            end;
         end
         else
            MessageDlg('Cell No. must be a hex with length not exceeding 2 digit.' ,
                              mtError, [mbOK], 0);
      end
      else
         MessageDlg('Specify Cell No. to proceed.',
                           mtError, [mbOK], 0);
   end;


{******************************************************************************
Function        : OverwriteBtnClick
{******************************************************************************}

procedure TMainForm.OverwriteBtnClick(Sender: TObject);
   var
      status, address, dataAccessCode : WORD;
      data : WORD;
   begin
      if (CellNumber.Text <> '') then
      begin
         if (length(CellNumber.Text )<= MAX_ADDRESS_LENGTH ) then
         begin
            try
               address := StrToInt('$' + CellNumber.Text);
               if Input.Text <> '' then
               begin
                  if (length(Input.Text )<= MAX_DATA_LENGTH ) then
                  begin
                     try
                        data := StrToInt('$' + Input.Text);
                        if AccessCode.Text <> '' then
                        begin
                           try
                              if (not((StrToInt(AccessCode.Text) <MIN_ACCESS_CODE )or (StrToInt(AccessCode.Text)>MAX_ACCESS_CODE))) then
                              begin
				if (Valid_OWritePW) then
                                 begin
                                    dataAccessCode := StrToInt(AccessCode.Text);
                                    status := SproOverwrite(@thePacket, WritePW, OverWritePW1,
                                    OverWritePW2, address, data, dataAccessCode);

                                    if status=0 then
                                    BEGIN
                          AccessCode.Text := '';
                                    Input.Text := '';
                                    CellNumber.Text := '';
                                    Output.Text :='';
                                       StatusLine.Text:='';
                                       StatusLine.Text := 'Overwrite successful! ';
                                    end
                                    else
                                    begin
                                       StatusLine.Text:='';
                                       StatusLine.Text := 'Overwrite failed!'+#13 +#10;
                                       StatusLine.Text := StatusLine.Text + 'Return code is '+ IntToStr(status)+ '.';
                                    end;
                                 end
                                 else
                                    MessageDlg('Specify Write, Overwrite Passwords using Passwords button to proceed.',
                                                      mtError, [mbOK], 0);
                              end
                              else
                                 MessageDlg('Access Code must be between 0 to 3.',
                                                   mtError, [mbOK], 0);
                           except
                              on EConvertError do
                                 MessageDlg('Access Code must be between 0 to 3.',
                                                   mtError, [mbOK], 0);
                           end;
                        end
                        else
                           MessageDlg('Specify an Access Code to proceed.',
                                             mtError, [mbOK], 0);
                     except
                        on EConvertError do
                           MessageDlg('Data to be written must be a hex with length not exceeding 4 digit.',
                                             mtError, [mbOK], 0);
                     end;
                  end
                  else
                     MessageDlg('Data to be written must be a hex with length not exceeding 4 digit.' ,
                                       mtError, [mbOK], 0);
               end
               else
                  MessageDlg('Specify a data to be written in input box to proceed.',
                                    mtError, [mbOK], 0);
            except
               on EConvertError do
                  MessageDlg('Cell No. must be in hex with length not exceeding 2 digit.',
                                    mtError, [mbOK], 0);
            end;
         end
         else
            MessageDlg('Cell No. must be in hex with length not exceeding 2 digit.' ,
                              mtError, [mbOK], 0);
      end
      else
         MessageDlg('Specify Cell No. to proceed.',
                           mtError, [mbOK], 0);
   end;




{******************************************************************************
Function        : WriteBtnClick
{******************************************************************************}

procedure TMainForm.WriteBtnClick(Sender: TObject);
   var
      status, address, dataAccessCode : WORD;
      data : WORD;
   begin
      if (CellNumber.Text <> '') then
      begin
         if (length(CellNumber.Text )<= MAX_ADDRESS_LENGTH ) then
         begin
            try
               address := StrToInt('$' + CellNumber.Text);
               if Input.Text <> '' then
               begin
                  if (length(Input.Text )<= MAX_DATA_LENGTH ) then
                  begin
                     try
                        data := StrToInt('$' + Input.Text);
                        if AccessCode.Text <> '' then
                        begin
                           try
                              if (not((StrToInt(AccessCode.Text) <MIN_ACCESS_CODE)or (StrToInt(AccessCode.Text)>MAX_ACCESS_CODE))) then
                              begin
				if ((Valid_OWritePW) or (Valid_WritePW)) then
                                 begin
                                    dataAccessCode := StrToInt(AccessCode.Text);
                                    status := SproWrite(@thePacket, WritePW, address, data,dataAccessCode);


                                    if status=0 then
                                    begin
                        AccessCode.Text := '';
                                    Input.Text := '';
                                    CellNumber.Text := '';
                                    Output.Text :='';
                                    StatusLine.Text:='';
                                    StatusLine.Text := 'Write successfull! ';
                                    end
                                    else
                                    begin
                                    StatusLine.Text:='';
                                    StatusLine.Text := 'Write failed!'+#13 +#10;
                                    StatusLine.Text := StatusLine.Text + 'Return code is '+ IntToStr(status)+ '.';
                                    end;
                                 end
                                 else
                                    MessageDlg('Specify Write Password using Passwords button to proceed.',
                                                      mtError, [mbOK], 0);
                              end
                              else
                                 MessageDlg('Access Code must be between 0 to 3.',
                                                   mtError, [mbOK], 0);
                           except
                              on EConvertError do
                                 MessageDlg('Access Code must be between 0 to 3.',
                                                   mtError, [mbOK], 0);
                           end;
                        end
                        else
                           MessageDlg('Specify an Access Code to proceed.',
                                             mtError, [mbOK], 0);
                     except
                        on EConvertError do
                           MessageDlg('Data to be written must be a hex with length not exceeding 4 digit.',
                                             mtError, [mbOK], 0);
                     end;
                  end
                  else
                     MessageDlg('Data to be written must be a hex with length not exceeding 4 digit.',
                                       mtError, [mbOK], 0);
               end
               else
                  MessageDlg('Specify data to be written in input box to proceed.',
                                    mtError, [mbOK], 0);
            except
               on EConvertError do
                  MessageDlg('Cell No. must be in hex with length not exceeding 2 digit.',
                                    mtError, [mbOK], 0);
            end;
         end
         else
            MessageDlg('Cell No. must be in hex with length not exceeding 2 digit.',
                              mtError, [mbOK], 0);
      end
      else
         MessageDlg('Specify Cell No. to proceed.',
                           mtError, [mbOK], 0);
   end;



{******************************************************************************
Function        : QueryBtnClick
{******************************************************************************}

procedure TMainForm.QueryBtnClick(Sender: TObject);
var
	queryStr, realQueryStr, responseStr, disResponseStr : string[120];
	address, status : WORD;
   temqueryStr :Extended ;
	response32 : longint;
	begin
		if (CellNumber.Text <> '') then
		begin
			if (length(CellNumber.Text )<= MAX_ADDRESS_LENGTH ) then
			begin
				try
					address := StrToInt('$' + CellNumber.Text);
					if (Input.Text <> '') then
					begin
						if (not ((length(Input.Text )<MIN_QUERY_LENGTH )or (length(Input.Text )>MAX_QUERY_LENGTH*2 ))) then
						begin
							if ((length(Input.Text )mod 2)=0 )  then
							begin
								try

                  temqueryStr:=IsHexChar(Input.Text);
                  if (temqueryStr=0) then
                  begin
                  //temqueryStr:=StrToInt64('$' + copy(Input.Text,length(Input.Text )/),);
                  queryStr := Input.Text;
                  ConvertQueryStr(queryStr, realQueryStr);
									status := SproQuery (@thePacket, address, @realQueryStr[1],
																				@responseStr[1], response32,
									Length(realQueryStr));
									{ response string has same length as real query string }
									responseStr[0] := realQueryStr[0];
									ConvertResponseStr (responseStr, disResponseStr);

									if status <> 0 then
									begin
										Output.Text :='';
										StatusLine.Text:='';
										StatusLine.Text := 'Query failed!'+#13 +#10;
										StatusLine.Text := StatusLine.Text + 'Return code is '+ IntToStr(status)+ '.';
									end
									else
									begin
                  AccessCode.Text := '';
									Input.Text := '';
									CellNumber.Text := '';

									Output.Text := disResponseStr;
									StatusLine.Text:='';
									StatusLine.Text := 'Query successful!';
									end;
                end
                else
	MessageDlg('Query data must be in hex. The length of data must be even and between 8 to 112.',
														mtError, [mbOK], 0);
           			except
								on EConvertError do
									MessageDlg('Query data must be in hex. The length of data must be even and between 8 to 112.',
														mtError, [mbOK], 0);
							end;
							end
							else
								MessageDlg('Query data must be in hex. The length of data must be even and between 8 to 112.' ,
														mtError, [mbOK], 0);
						end
						else
							MessageDlg('Query data must be in hex. The length of data must be even and between 8 to 112.' ,
													mtError, [mbOK], 0);
					end
					else
						MessageDlg('Specify query data in input box to proceed.',
												mtError, [mbOK], 0);
				except
					on EConvertError do
						MessageDlg('Cell No. must be in hex with length not exceeding 2 digit.',
												mtError, [mbOK], 0);
				end;
			end
			else
				MessageDlg('Cell No. must be in hex with length not exceeding 2 digit.',
										mtError, [mbOK], 0);
		end
		else
		MessageDlg('Specify Cell No. to proceed.',
								mtError, [mbOK], 0);
	end;



{******************************************************************************
Function        : DecrementBtnClick
{******************************************************************************}

procedure TMainForm.DecrementBtnClick(Sender: TObject);
var
   status, address : WORD;
   begin
      if (CellNumber.Text <> '') then
      begin
         if (length(CellNumber.Text )<= MAX_ADDRESS_LENGTH ) then
         begin
  	if ((Valid_OWritePW) or (Valid_WritePW)) then
            begin
               try
                  address := StrToInt('$' + CellNumber.Text);
                  status := SproDecrement(@thePacket, WritePW, address);

                  if status=0 then
                  begin
               AccessCode.Text := '';
                  CellNumber.Text := '';
                  Input.Text := '';
                  Output.Text := '';
                     StatusLine.Text:='';
                     StatusLine.Text := 'Decrement successful! ';
                  end
                  else
                  begin
                     StatusLine.Text:='';
                     StatusLine.Text := 'Decrement failed!'+#13 +#10;
                     StatusLine.Text := StatusLine.Text + 'Return code is '+ IntToStr(status)+ '.';
                  end;
               except
                  on EConvertError do
                     MessageDlg('Cell No. must be in hex with length not exceeding 2 digit.',
                                       mtError, [mbOK], 0);
               end;
            end
            else
               MessageDlg('Specify Write Password under Miscellaneous group box to proceed.',
                                 mtError, [mbOK], 0);
         end
         else
            MessageDlg('Cell No. must be in hex with length not exceeding 2 digit.',
                              mtError, [mbOK], 0);
      end
      else
         MessageDlg('Specify Cell No. to proceed.',
                           mtError, [mbOK], 0);
   end;


{******************************************************************************
Function        : ActivateBtnClick
{******************************************************************************}

procedure TMainForm.ActivateBtnClick(Sender: TObject);
  var
		status, address : WORD;
	begin
		if (CellNumber.Text <> '') then
		begin
			if (length(CellNumber.Text )<= MAX_ADDRESS_LENGTH ) then
			begin
			  	if ((Valid_OWritePW) or (Valid_WritePW)) then
				begin


				try
					address := StrToInt('$' + CellNumber.Text);
					ActivateForm.AP1.Text:='';
					ActivateForm.AP2.Text:='';
					if ActivateForm.ShowModal = mrOk then
					begin
						status := SproActivate(@thePacket, WritePW, pwWord1, pwWord2, address);

						if status=0 then
						begin
              AccessCode.Text := '';
						CellNumber.Text := '';
						Input.Text := '';
						Output.Text := '';

							StatusLine.Text:='';
							StatusLine.Text := 'Activate successful! ';
						end
						else
						begin
							StatusLine.Text:='';
							StatusLine.Text := 'Activate failed!'+#13 +#10;
							StatusLine.Text := StatusLine.Text + 'Return code is '+ IntToStr(status)+ '.';
						end;
					end
				except
					on EConvertError do
						MessageDlg('Cell No. must be in hex with length not exceeding 2 digit.',
												mtError, [mbOK], 0);
				end;
            end
				else
					MessageDlg('Specify Write Password under Miscellaneous group box to proceed.',
											mtError, [mbOK], 0);
			end
			else
				MessageDlg('Cell No. must be in hex with length not exceeding 2 digit.',
										mtError, [mbOK], 0);
		end
		else
			MessageDlg('Specify Cell No. to proceed.',
									mtError, [mbOK], 0);
	end;



{******************************************************************************
Function        : StatusBtnClick
{******************************************************************************}

procedure TMainForm.StatusBtnClick(Sender: TObject);
   var
      status : WORD;
   begin
      status := SproGetFullStatus(@thePacket);
      CellNumber.Text := '';
      AccessCode.Text := '';
      Input.Text := '';
      Output.Text := '';
     StatusLine.Text:='';
      StatusLine.Text := 'GetFullStatus successful!'+#13 +#10;
         StatusLine.Text := StatusLine.Text + 'Status of last API called '+ IntToStr(status)+ '.';

   end;




{******************************************************************************
Function        : VersionBtnClick
{******************************************************************************}

procedure TMainForm.VersionBtnClick(Sender: TObject);
   var
      status : WORD;
      majVer, minVer, rev, osDrvrType : BYTE;
   begin
      status := SproGetVersion(@thePacket, majVer, minVer, rev, osDrvrType);

      if status=0 then
      begin
      CellNumber.Text := '';
      AccessCode.Text := '';
      Input.Text := '';
      Output.Text := '';
         StatusLine.Text:='';
         StatusLine.Text := 'GetVersion successful! ' ;
         MessageDlg('Major Version: ' + IntToStr(majVer)+ #13 +#10 + 'Minor Version: ' + IntToStr(minVer) + #13 +#10 +
         'Revision: ' + IntToStr(rev) + #13 + #10'OS Driver Type: ' +
         DriverType(osDrvrType), mtInformation, [mbOK], 0);
      end
      else
      begin
         StatusLine.Text:='';
         StatusLine.Text := 'GetVersion failed!'+#13 +#10;
         StatusLine.Text := StatusLine.Text + 'Return code is '+ IntToStr(status)+ '.';
      end;
   end;


{******************************************************************************
Function        : KeyGridSelectCell
{******************************************************************************}

procedure TMainForm.KeyGridSelectCell(Sender: TObject; Col, Row: Longint;  var CanSelect: Boolean);
   begin
      CellNumber.Text := IntToHex((Row - 1) * 16 + (Col - 1), 2);
   end;




{******************************************************************************
Function        : SetContactSrvBtnClick
{******************************************************************************}

procedure TMainForm.SetContactSrvBtnClick(Sender: TObject);
	var
		status : WORD;
		server_name:  string ;
	begin
                server_name:= '';
                server_name :=ServerName.Text;
		if (length(server_name)<=MAX_SERVER_LENGTH - 1) then
        		begin
                                if (length(server_name)<=0 ) then
                                server_name:= ' ';
				status := SproSetContactServer(@thePacket, server_name);
                                if status=0 then
				begin
                                AccessCode.Text := '';
				Input.Text := '';
				CellNumber.Text := '';
				Output.Text := '';
				StatusLine.Text:='';
				StatusLine.Text := 'SetContactServer sucessful! ';
				end
				else
				begin
					StatusLine.Text:='';
					StatusLine.Text := 'SetContactServer failed!'+#13 +#10;
					StatusLine.Text := StatusLine.Text + 'Return code is '+ IntToStr(status)+ '.';

				end;
			end
			else
				MessageDlg('ContactServer name length must not be exceeded 63. ',
										mtError, [mbOK], 0);
	end;

{******************************************************************************
Function        : GetContactSrvClick
{******************************************************************************}

procedure TMainForm.GetContactSrvClick(Sender: TObject);
	var
		status : WORD;
		ServerNameStr : array [0..64] of Char;
	begin
		status := SproGetContactServer(@thePacket,ServerNameStr,64);

		if status <> 0 then
		begin
      Output.Text :='';
		StatusLine.Text:='';
		StatusLine.Text := 'GetContactServer failed!'+#13 +#10;
		StatusLine.Text := StatusLine.Text + 'Return code is '+ IntToStr(status)+ '.';
		end
		else
		begin
                AccessCode.Text := '';
		Input.Text := '';
		CellNumber.Text := '';
		Output.Text := string(ServerNameStr);
		StatusLine.Text:='';
		StatusLine.Text := 'GetContactServer successful!';
		end;
	end;


{******************************************************************************
Function        : GetSubLicBtnClick
{******************************************************************************}

procedure TMainForm.GetSubLicBtnClick(Sender: TObject);
   var
      status, address : WORD;

   begin
      if (CellNumber.Text <> '') then
      begin
         if (length(CellNumber.Text )<= MAX_ADDRESS_LENGTH ) then
         begin
            try
               address := StrToInt('$' + CellNumber.Text);
               status := SproGetSubLicense(@thePacket, address);

               if status=0 then
                begin
                  AccessCode.Text := '';
                  Input.Text := '';
                  CellNumber.Text := '';
                  Output.Text := '';
                  StatusLine.Text:='';
                  StatusLine.Text := 'GetSubLicense sucessful! ';
                end
               else
                begin
                  StatusLine.Text:='';
                  StatusLine.Text := 'GetSubLicense failed!'+#13 +#10;
                  StatusLine.Text := StatusLine.Text + 'Return code is '+ IntToStr(status)+ '.';
                end;
            except
               on EConvertError do
                  MessageDlg('Cell No. must be in hex with length not exceeding 2 digit.',
                                    mtError, [mbOK], 0);
            end;
         end
         else
            MessageDlg('Cell No. must be in hex with length not exceeding 2 digit.',
                              mtError, [mbOK], 0);
      end
      else
         MessageDlg('Specify Cell No. to proceed.',
                           mtError, [mbOK], 0);
   end;



{******************************************************************************
Function        : ReleaseLicBtnClick
{******************************************************************************}

procedure TMainForm.ReleaseLicBtnClick(Sender: TObject);
	var
		status, address : WORD;
		numSubLic : WORD;
	begin
		if (CellNumber.Text <> '') then
		begin
			if (length(CellNumber.Text )<= MAX_ADDRESS_LENGTH ) then
			begin
				try
					address := StrToInt('$' + CellNumber.Text);
				//	if address <> 0 then
					//begin
						if (Input.Text <> '') then
						begin
							try
								if ((StrToInt(Input.Text) >= MIN_NUM_LICENESE)and (StrToInt(Input.Text) <= MAX_NUM_LICENESE)) then
								begin
									numSubLic := StrToInt('$' + Input.Text);
									status := SproReleaseLicense(@thePacket, address,@numSubLic);

									if (status <> 0)  then
									begin
										StatusLine.Text:='';
										StatusLine.Text := 'ReleaseLicense failed!'+#13 +#10;
										StatusLine.Text := StatusLine.Text + 'Return code is '+ IntToStr(status)+ '.';
									 	Output.Text := ''
									end
									else
									begin
                    AccessCode.Text := '';
									Input.Text := '';
									CellNumber.Text := '';

										StatusLine.Text:='';
										StatusLine.Text := 'ReleaseLicense successful!';
										Output.Text := IntToHex(numSubLic, 4);
									end;
								end
								else
									MessageDlg('Number of sublicense to release must be an integer between 0 to 65535.',
															mtError, [mbOK], 0);
							except
								on EConvertError do
									MessageDlg('Number of sublicense to release must be an integer between 0 to 65535.',
															mtError, [mbOK], 0);
							end;
						end
						else
							MessageDlg('Specify number of license to release in input box to proceed.',
													mtError, [mbOK], 0);

					//else
					//begin
				except
					on EConvertError do
						MessageDlg('Cell No. must be in hex with length not exceeding 2 digit.',
												mtError, [mbOK], 0);
				end;
			end
			else
				MessageDlg('Cell No. must be in hex with length not exceeding 2 digit.',
										mtError, [mbOK], 0);
		end
		else
			MessageDlg('Specify Cell No. to proceed.',
									mtError, [mbOK], 0);
	end;



{******************************************************************************
Function        : InitializeBtnClick
{******************************************************************************}

procedure TMainForm.InitializeBtnClick(Sender: TObject);
   var
      status : WORD;
   begin
      { Initialize the driver }
      status := SproInitialize(@thePacket);
      if status=0 then
      begin
            AccessCode.Text := '';
      CellNumber.Text := '';
      Input.Text := '';
      Output.Text := '';

         StatusLine.Text:='';
         StatusLine.Text := 'Initialize successful!'
      end
      else
      begin
         StatusLine.Text:='';
         StatusLine.Text := 'Initialize failed!'+#13 +#10;
         StatusLine.Text := StatusLine.Text + 'Return code is '+ IntToStr(status)+ '.';
      end;

   end;



{******************************************************************************
Function        : GetHardLmtClick
{******************************************************************************}

procedure TMainForm.GetHardLmtClick(Sender: TObject);
   var
      status,hardLmt : WORD;
   begin
      status := SproGetHardLimit(@thePacket,@hardLmt);
      if (status <> 0)  then
      begin
         Output.Text := '';
         StatusLine.Text:='';
         StatusLine.Text := 'GetHardLimit failed!'+#13 +#10;
         StatusLine.Text := StatusLine.Text + 'Return code is '+ IntToStr(status)+ '.';
      end
      else
      begin
      AccessCode.Text := '';
      CellNumber.Text := '';
      Input.Text := '';

         Output.Text := IntToStr(hardLmt);
         StatusLine.Text:='';
         StatusLine.Text := 'GetHardLimit successful!';
      end;
   end;


{******************************************************************************
Function        : HeartBeatClick
{******************************************************************************}

procedure TMainForm.HeartBeatClick(Sender: TObject);
   var
      status : WORD;
      heartbeat : Longint   ;
   begin
      if (Input.Text <> '') then
      begin
         try
            heartbeat := StrToInt(Input.Text);
            if (not((heartbeat > MAX_HEARTBEAT )or (heartbeat <MIN_HEARTBEAT ))or ( heartbeat = -1 )) then
            begin
               status := SproSetHeartBeat(@thePacket,heartbeat);
               if status=0 then
               begin
               CellNumber.Text := '';
               AccessCode.Text := '';
               Input.Text := '';
               Output.Text :='';

                  StatusLine.Text:='';
                  StatusLine.Text := 'SetHeartBeat successful! ';
               end
               else
               begin
                  StatusLine.Text:='';
                  StatusLine.Text := 'SetHeartBeat failed!'+#13 +#10;
                  StatusLine.Text := StatusLine.Text + 'Return code is '+ IntToStr(status)+ '.';
               end;
            end
            else
            MessageDlg('Heartbeat value must be an integer between 60 to 2592000. Enter -1 for infinite heartbeat.',
            mtError, [mbOK], 0);
         except
            on EConvertError do
               MessageDlg('Heartbeat value must be an integer between 60 to 2592000. Enter -1 for infinite heartbeat.',
                                 mtError, [mbOK], 0);
         end;
      end
      else
         MessageDlg('Specify heartbeat value to proceed.',
                           mtError, [mbOK], 0);
   end;



{******************************************************************************
Function        : SetProtocolClick
{******************************************************************************}

procedure TMainForm.SetProtocolClick(Sender: TObject);
   var
      ProtocolFlag, status : Word;
      index : Word;
   begin
      index := ComboBoxProtocolFlag.ItemIndex ;
      if ((index <> 0 )and (index <> 1)and (index <> 2)and (index <> 3)) then
         MessageDlg('Select a value for protocol to proceed.',
                           mtError, [mbOK], 0)
      else
      begin
         if index = 0  then
            Protocolflag := NSPRO_TCP_PROTOCOL
         else if index = 1  then
            ProtocolFlag := NSPRO_IPX_PROTOCOL
         else if index = 2  then
            ProtocolFlag :=  NSPRO_NETBEUI_PROTOCOL
         else if index = 3  then
            ProtocolFlag :=  NSPRO_SAP_PROTOCOL
         else
            Protocolflag := NSPRO_TCP_PROTOCOL ;
         status := SproSetProtocol(@thePacket, ProtocolFlag);
         if status=0 then
         begin
         CellNumber.Text := '';
         AccessCode.Text := '';
         Input.Text := '';
         Output.Text :='';
            StatusLine.Text:='';
            StatusLine.Text := 'SetProtocol successful! ';
         end
         else
         begin
            StatusLine.Text:='';
            StatusLine.Text := 'SetProtocol failed!'+#13 +#10;
            StatusLine.Text := StatusLine.Text + 'Return code is '+ IntToStr(status)+ '.';
         end;
      end ;
   end;


{******************************************************************************
Function        : FormatPktClick
{******************************************************************************}

procedure TMainForm.FormatPktClick(Sender: TObject);
   var
      status : WORD;
   begin
      status := SproFormatPacket(@thePacket,RB_SPRO_APIPACKET_SIZE);

      if status=0 then
      begin
      CellNumber.Text := '';
      AccessCode.Text := '';
      Input.Text := '';
        Output.Text :='';
         StatusLine.Text:='';
         StatusLine.Text := 'FormatPacket successful! '
      end
      else
      begin
         StatusLine.Text := 'FormatPacket failed!'+#13 +#10;
         StatusLine.Text := StatusLine.Text + 'Return code is '+ IntToStr(status)+ '.';
      end;
   end;


{******************************************************************************
Function        : KeyInfoClick
{******************************************************************************}

procedure TMainForm.KeyInfoClick(Sender: TObject);
   begin
      NextKey:=0;
      KeyInfoForm.E_iKeyID.Text := 'FFFF';
      KeyInfoForm.ShowModal;
   end;


{******************************************************************************
Function        : EnumServerClick
{******************************************************************************}

procedure TMainForm.EnumServerClick(Sender: TObject);
   begin
      EnumServerForm.E_iDevID.Text:= 'FFFF';
      EnumServerForm.E_i_NumServers.Text:= '10';
      EnumServerForm.C_iEnumFlag.ItemIndex :=1;
      EnumServerForm.ShowModal;

   end;


END.


